package com.ebaiyihui.family.doctor.server.controller;


import com.ebaiyihui.family.doctor.common.dto.InsertPatientMedicalRecordDTO;
import com.ebaiyihui.family.doctor.common.dto.InvalidMedicalRecordDTO;
import com.ebaiyihui.family.doctor.common.dto.UpdatePatientMedicalRecordDTO;
import com.ebaiyihui.family.doctor.common.vo.InsertPatientMedicalRecordVO;
import com.ebaiyihui.family.doctor.common.vo.PatientMedicalRecordVO;
import com.ebaiyihui.family.doctor.server.service.PatientMedicalRecordService;
import com.ebaiyihui.framework.response.BaseResponse;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import java.util.Objects;

@RestController
@RequestMapping("/medicalRecord")
@Api(tags = "患者病历API")
public class PatientMedicalRecordController {

    @Autowired
    private PatientMedicalRecordService patientMedicalRecordService;

//    @PostMapping("/insert")
//    @ApiOperation(value = "新建复诊病历", notes = "医生开具复诊病历")
//    public BaseResponse<InsertPatientMedicalRecordVO> insert(@RequestBody @Validated InsertPatientMedicalRecordDTO dto,
//                                                             BindingResult bindingResult) {
//        if (bindingResult.hasErrors()) {
//            return BaseResponse.error(Objects.requireNonNull(bindingResult.getFieldError()).getDefaultMessage());
//        }
//        return patientMedicalRecordService.insertPatientMedicalRecord(dto);
//    }
//
//    @PostMapping("/update")
//    @ApiOperation(value = "修改复诊病历", notes = "医生修改复诊病历")
//    public BaseResponse<InsertPatientMedicalRecordVO> update(@RequestBody @Validated UpdatePatientMedicalRecordDTO dto,
//                                                             BindingResult bindingResult) {
//        if (bindingResult.hasErrors()) {
//            return BaseResponse.error(Objects.requireNonNull(bindingResult.getFieldError()).getDefaultMessage());
//        }
//        return patientMedicalRecordService.updatePatientMedicalRecord(dto);
//    }
//
//    @PostMapping("/insertOrUpdate")
//    @ApiOperation(value = "新建或修改复诊病历", notes = "新建或修改复诊病历")
//    public BaseResponse<Object> insertOrUpdate(@RequestBody @Validated InsertPatientMedicalRecordDTO dto,
//                                                             BindingResult bindingResult) {
//        if (bindingResult.hasErrors()) {
//            return BaseResponse.error(Objects.requireNonNull(bindingResult.getFieldError()).getDefaultMessage());
//        }
//        return patientMedicalRecordService.insertOrUpdate(dto);
//    }
//
//    @PostMapping("/detail")
//    @ApiOperation(value = "复诊病历详情", notes = "复诊病历详情")
//    public BaseResponse<PatientMedicalRecordVO> detail(@RequestBody @Validated InvalidMedicalRecordDTO dto,
//                                                       BindingResult bindingResult) {
//        if (bindingResult.hasErrors()) {
//            return BaseResponse.error(Objects.requireNonNull(bindingResult.getFieldError()).getDefaultMessage());
//        }
//        return patientMedicalRecordService.detailMedicalRecord(dto);
//    }

    @ApiOperation(value = "推送病例卡片", notes = "医生开具复诊病例推送小卡片")
    @RequestMapping(value = "/treatmentCard", method = RequestMethod.POST)
    public BaseResponse<Object> treatmentCard(@RequestBody @Validated InvalidMedicalRecordDTO param,
                                            BindingResult bindingResult) {
        if (bindingResult.hasErrors()) {
            return BaseResponse.error(Objects.requireNonNull(bindingResult.getFieldError()).getDefaultMessage());
        }
        return patientMedicalRecordService.treatmentCard(param.getAdmId());
    }





}
